/*****************************************************************************************
   Copyright:	Inverse groupe conseil, 2006
   Author: 		Robert Bolduc (except for gAddressBookAbListener, author unknown)
   Email:		support@inverse.ca
   URL:			http://inverse.ca
   
   This file is part of "Addressbook GroupDAV Connector" a Thunderbird extension.
   
   "Addressbook GroupDAV Connector" is free software; you can redistribute it
   and/or modify it under the terms of the GNU General Public License version 2
   as published by the Free Software Foundation;

   "Addressbook GroupDAV Connector" is distributed in the hope that it will be
   useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with "Addressbook GroupDAV Connector"; if not, write to the
   Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
   02110-1301  USA
********************************************************************************/

/*
 * This overlay adds GroupDAV functionalities to Addressbooks
 */


//var gProgressMeter;
//var gAbWinObserverService =Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

var gSynchIsRunning = false;
var gSelectedDir = "";

// Add some more treatment on the onload event,
// It seems that it is not possible to overlay the onload event of the addressbook:
//
// See line 159 in chrome://messenger/content/addressbook/addressbook.js:
//// FIX ME - later we will be able to use onload from the overlay
//  	OnLoadCardView();
//
//  	SetupAbCommandUpdateHandlers();
//
////workaround - add setTimeout to make sure dynamic overlays get loaded first

/*****************************************************************************************
 *
 *  UI functions
 *
 *****************************************************************************************/
function AbNewGroupDavContacts() {
  window.openDialog("chrome://groupdav-addressbook/content/preferences.addressbook.groupdav.xul",  "",
                    "chrome,modal=yes,resizable=no,centerscreen", null);
}

function EditGroupDavDirectory() {
  window.openDialog("chrome://groupdav-addressBook/content/preferences.addressbook.groupdav.xul",  "",
                    "chrome,modal=yes,resizable=no,centerscreen", GetSelectedDirectory());
}

function openGroupdavPreferences(abUri) {
  window.openDialog("chrome://groupdav-addressBook/content/preferences.addressbook.groupdav.xul",  "",
                    "chrome,modal=yes,resizable=no,centerscreen", abUri);
}

/********************************************************************************************
 *
 *  Override of the  UI functionalities
 *
 ********************************************************************************************/
function disableNewList() {
  try {
    var node = document.getElementById("button-newlist");
    if ( node && isGroupdavDirectory(gSelectedDir)) {
      node.setAttribute('disabled', 'true');
    }
    else {
      node.removeAttribute('disabled');
    }
  }
  catch (e) {}//Do nothing, exceptions happen before the addressbook is actully loaded
}

function goUpdateGlobalEditMenuItemsOverlay() {
  try {
    gSelectedDir = GetSelectedDirectory();
    goUpdateCommand("cmd_synchGroupdav");
    goUpdateGlobalEditMenuItems();
    disableNewList();
  }
  catch (e) {
    //		exceptionHandler(window,"Error",e);
  }
}
function CommandUpdate_AddressBookGroupdavOverlay() {
  try {
    gSelectedDir = GetSelectedDirectory();
    goUpdateCommand('cmd_synchGroupdav');
    CommandUpdate_AddressBook();
    disableNewList();
  }
  catch (e) {
    //		exceptionHandler(window,"Error",e);
  }
}
function goUpdateSelectEditMenuItemsGroupdavOverlay() {
  try {
    gSelectedDir = GetSelectedDirectory();
    goUpdateCommand('cmd_synchGroupdav');
    goUpdateSelectEditMenuItems();
    disableNewList();
  }
  catch (e) {
    //alert(e + "\nstack:\n" + e.stack);
    //		exceptionHandler(window,"Error",e);
  }
}

//Overidde AbEditSelectedDirectory function in chrome://messenger/content/addressbook/abCommon.js
var  AbEditSelectedDirectoryOriginal = AbEditSelectedDirectory;
var  AbEditSelectedDirectory = function() {
  var abUri = GetSelectedDirectory();
  if(isGroupdavDirectory(abUri))
  openGroupdavPreferences(abUri);
  else
  AbEditSelectedDirectoryOriginal.apply();
};

//Overidde DirPaneDoubleClick function in chrome://messenger/content/addressbook/abCommon.js
//I am not happy to rewrite DirPaneDoubleClick but enough is enough!
var DirPaneDoubleClick = function(event) {
  // we only care about left button events
  if (event.button != 0)
  return;

  var row = dirTree.treeBoxObject.getRowAt(event.clientX, event.clientY);
  if (row == -1 || row > dirTree.view.rowCount-1) {
    // double clicking on a non valid row should not open the dir properties dialog
    return;
  }
  if (dirTree && dirTree.view.selection && dirTree.view.selection.count == 1) {
    var abUri = GetSelectedDirectory();
    if(isGroupdavDirectory(abUri))
    openGroupdavPreferences(abUri);
    else
    AbEditSelectedDirectoryOriginal.apply();
  }
}

// Additionnal Controller object for Dir Pane
var dirPaneControllerOverlay = {
  supportsCommand: function(command) {
    switch (command) {
      case "cmd_synchGroupdav":
      //			case "cmd_delete":
      //			case "button_delete":
      return true;
      default:
      return false;
    }
  },
  isCommandEnabled: function(command) {
    try {
      switch (command) {
        case "cmd_synchGroupdav":
        if (gSelectedDir && gSelectedDir != "" && isGroupdavDirectory(gSelectedDir) && !gSynchIsRunning) {
          return true;
        }
        else {
          return false;
        }
        //				case "cmd_delete":
        //				case "button_delete":
        //					return true;
        default:
        return false;
      }
    }
    catch (e) {
      exceptionHandler(window,"Exception",e);
    }
    return false;
  },
  doCommand: function(command) {
    switch (command) {
      case "cmd_synchGroupdav":
      SynchronizeGroupdavAddressbook();
      break;
      //			case "cmd_delete":
      //			case "button_delete":
      //				break;
    }
    if (command == "cmd_synchGroupdav")
    SynchronizeGroupdavAddressbook();
  },
  onEvent: function(event) {
  }
};

//Overidde SetupAbCommandUpdateHandlers function in chrome://messenger/content/addressbook/abCommon.js
//I am not happy to rewrite SetupAbCommandUpdateHandlers but enough is enough!
function SetupAbCommandUpdateHandlers() {
  // dir pane
  if (dirTree) {
    dirTree.controllers.appendController(dirPaneControllerOverlay);
    dirTree.controllers.appendController(DirPaneController);
  }
  // results pane
  if (gAbResultsTree) {
    gAbResultsTree.controllers.appendController(ResultsPaneController);
    gAbResultsTree.controllers.appendController(dirPaneControllerOverlay);
  }
}

//Override of gAddressBookAbListener in chrome://messenger/content/addressbook/addressbook.js
gAddressBookAbListener = {
  onItemAdded: function(parentDir, item) {
    // will not be called
  },
  onItemRemoved: function(parentDir, item) {
    // will only be called when an card in a GroupDAV addressbook is deleted

    try {
    	// Addition to delete the card on the groupdav server
    	if (item && (item instanceof Components.interfaces.nsIAbCard) && (parentDir instanceof Components.interfaces.nsIAbDirectory) 
    				&& isGroupdavDirectory(gSelectedDir)
    				&& (localDeleteHash.size == 0 || (localDeleteHash.size > 0 &&  localDeleteHash[item.custom3] ))){

				var groupdavPrefService = new GroupdavPreferenceService(GetDirectoryFromURI(gSelectedDir).dirPrefId);
				var url = groupdavPrefService.getURL();
				var user = groupdavPrefService.getUser();
				var password = getPassword(groupdavPrefService.getHostName(), user);
			   var href =  url + item.custom3;
				webdav_delete(href,user,password);
				logDebug("   webdav_delete: " + href);  			

		}//end addition. The rest of the code of this listener is used under license MPL 1.1/GPL 2.0/LGPL 2.1
		 //and comes from chrome://messenger/content/addressbook/addressbook.js
		
      // If we don't have a record of the previous selection, the only
      // option is to select the first.
      if (gPreviousDirTreeIndex == -1) {
        SelectFirstAddressBook();
      }
      else {
        // Don't reselect if we already have a valid selection, this may be
        // the case if items are being removed via other methods, e.g. sidebar,
        // LDAP preference pane etc.
        if (dirTree.currentIndex == -1) {
          var directory = item.QueryInterface(Components.interfaces.nsIAbDirectory);

          // If we are a mail list, move the selection up the list before
          // trying to find the parent. This way we'll end up selecting the
          // parent address book when we remove a mailing list.
          //
          // For simple address books we don't need to move up the list, as
          // we want to select the next one upon removal.
          if (directory.isMailList && gPreviousDirTreeIndex > 0)
          --gPreviousDirTreeIndex;

          // Now get the parent of the row.
          var newRow = dirTree.view.getParentIndex(gPreviousDirTreeIndex);

          // if we have no parent (i.e. we are an address book), use the
          // previous index.
          if (newRow == -1)
          newRow = gPreviousDirTreeIndex;

          // Fall back to the first adddress book if we're not in a valid range
          if (newRow >= dirTree.view.rowCount)
          newRow = 0;

          // Now select the new item.
          dirTree.view.selection.select(newRow);
        }
      }
    }
    catch (ex) {
      exceptionHandler(window, "Delete Card", ex);
    }
  },

  onItemPropertyChanged: function(item, property, oldValue, newValue) {
    // will not be called
  }
};
