/*    Orginal code from morescols extension vcardTools.js
 
  		<em:id>{3e17310d-82e8-4a43-bd2f-7c3055bfe589}</em:id>
		<em:name>MoreColsForAddressBook</em:name>
		<em:version>0.3.4.1</em:version>
		<em:description>Add some functions to the Addressbook</em:description>
		<em:creator>Paolo Kaosmos</em:creator>
		<em:homepageURL>https://nic-nac-project.de/~kaosmos/index-en.html</em:homepageURL>
 */

/**************************************************************************
 * Function to import directly the vcard.
 * It supports also vcf with multiple vcards inside and multiple vCards
 **************************************************************************/ 
function importFromVcard(vCardString, key, version, addressBook) {
	//xulFileWrite("/home/bolducr/workspace/Focus/groupdav/addressbook/vcard.vcf", vCardString);
	var vcardLines = new Array;	
	var end = new RegExp(/^END/);
 // The read lines are put into the vcardLines array until we find the ENDline

 var cardArray = vCardString.split(/[\r\n]+/);
 var j = 0;
 if(cardArray){
    for (var i=0; i < cardArray.length; i++){
       vcardLines[j] = cardArray[i];
       j++;
       if ( end.test(cardArray[i].toUpperCase()) ) {
          return CreateCardsFromVcf(addressBook, vcardLines, key, version);
//          vcardLines = new Array;
//          j = 0;
       }
    }
 }

  return false;
}


//function CreateCardsFromVcf(uri,lines, key, serverVersion) {
//	var card = parseCardFromVcf(uri,lines, key, serverVersion);
//	var directory = GetDirectoryFromURI(uri); 
// 	var addedCard = directory.addCard(card);
//}

function CreateCardsFromVcf(uri,lines, key, serverVersion) {
	var card = new Object;
	// Regexp to test the lines of the vcard
	var version = new RegExp(/^VERSION/);
	var names = new RegExp(/^N/);
	var fname = new RegExp(/^FN/);
	var nickname = new RegExp(/^NICKNAME/);
	var org = new RegExp(/^ORG/);
	var telhome = new RegExp(/^TEL.*HOME/);
	var telcell = new RegExp(/^TEL.*CELL/);
	var telfax = new RegExp(/^TEL.*FAX/);
	var telwork = new RegExp(/^TEL.*WORK/);
	var adrhome = new RegExp(/^ADR.*HOME/);
	var adrwork = new RegExp(/^ADR.*WORK/);
	var urlhome = new RegExp(/^URL.*HOME/);
	var urlwork = new RegExp(/^URL.*WORK/);
	var emailpref = new RegExp(/^EMAIL.*PREF/);
	var email = new RegExp(/^EMAIL/);
	var title = new RegExp(/^TITLE/);
	var bday = new RegExp(/^BDAY/);
	var notes = new RegExp(/^NOTE/);
	// Variables needed to fill the email fields
	var myfirstemail = "";
	var myemail = "";
	var myemail2 = "";
	for (i=0;i<lines.length;i++) {
	   var mylinevalue="";
	   var myline = lines[i];
	   // Find the value of the line, we use substring+indexOf instead
	   // split, because there could be value with : inside (es. urls)
	   mylinevalue = myline.substring(myline.indexOf(":")+1);
	   // Convert the hex 0D and 0A chars in \r and \n (vcard use hex notation)
	   mylinevalue = mylinevalue.replace(/(=0D|\\r)/g, "\r");
	   mylinevalue = mylinevalue.replace(/(=0A|\\n)/g, "\n");
	   // Split to find the label of the line
	   var mylineinit = myline.split(":");
	   mylineinit[0] = mylineinit[0].toUpperCase();
	   if (notes.test(mylineinit[0]) )
	      card.notes = mylinevalue;
	   // Cancel the newlines, the Notes field is the only one that supports them
	   mylineinit[0] = mylineinit[0].replace("\r\n","");
	   if ( mylineinit[0] == "N" ) {
	      // Split the value of N: to have the lastname and the firstname
	      var nameentries = mylinevalue.split(";");
	      var cognome = nameentries[0];
	      var nome = nameentries[1];
	      if (nome)
	         card.firstName = nome;
	      if (cognome)
	         card.lastName = cognome;
	   }
	   else if ( fname.test(mylineinit[0]) ) {
	      if (mylineinit[0].indexOf("QUOTE-PRINTABLE")) 
	         var fn = quoteprint(mylinevalue);
	      else
	         var fn = mylinevalue;
	       card.displayName = fn;
	   }
	   else if ( nickname.test(mylineinit[0]) ) 
	      card.nickName = mylinevalue;
	   else if ( org.test(mylineinit[0]) ) {
	      var orgentries = mylinevalue.split(";");
	      var orgcompany = orgentries[0];
	      var orgdepart = orgentries[1];
	      if (orgcompany) 
	         card.company = orgcompany;
	      if (orgdepart)
	         card.department = orgdepart;
	   }
	   else if ( telhome.test(mylineinit[0]) ) 
	      card.homePhone = mylinevalue;
	   else if ( telcell.test(mylineinit[0]) ) 
	      card.cellularNumber = mylinevalue;
	   else if ( telfax.test(mylineinit[0]) ) 
	      card.faxNumber = mylinevalue;
	   else if ( telwork.test(mylineinit[0]) ) 
	      card.workPhone = mylinevalue;
	   else if ( adrhome.test(mylineinit[0]) ) {
	      var adrentries = mylinevalue.split(";");
	      var indirizzo = adrentries[2];
	      var citta = adrentries[3];
	      var stato = adrentries[4];
	      var zipcode = adrentries[5];
	      var country = adrentries[6];
	      if (indirizzo) 
	         card.homeAddress = indirizzo;
	      if (citta)
	         card.homeCity = citta;
	      if (stato)
	         card.homeState = stato;
	      if (zipcode)
	         card.homeZipCode = zipcode;
	      if (country)
	         card.homeCountry = country;
	   }
	   else if ( adrwork.test(mylineinit[0]) ) {
	      var adrentries2 = mylinevalue.split(";");
	      var indirizzo2 = adrentries2[2];
	      var citta2 = adrentries2[3];
	      var stato2 = adrentries2[4];
	      var zipcode2 = adrentries2[5];
	      var country2 = adrentries2[6];
	      if (indirizzo2) 
	         card.workAddress = indirizzo2;
	      if (citta2)
	         card.workCity = citta2;
	      if (stato2)
	         card.workState = stato2;
	      if (zipcode2)
	         card.workZipCode = zipcode2;
	      if (country2)
	         card.workCountry = country2;
	   }
	   // With the email address, we must check if exists a label with the PREF
	   // parameters
	   // we will write the values after
	   else if ( emailpref.test(mylineinit[0]) ) 
	      myfirstemail = mylinevalue;
	   else if ( ! emailpref.test(mylineinit[0]) && email.test(mylineinit[0]) && myemail == "") 
	      myemail = mylinevalue;
	   else if ( ! emailpref.test(mylineinit[0]) && email.test(mylineinit[0]) && myemail != "") 
	      myemail2 = mylinevalue;
	   else if ( urlhome.test(mylineinit[0]) ) 
	      card.webPage2 = mylinevalue;
	   else if ( urlwork.test(mylineinit[0]) ) 
	      card.webPage = mylinevalue;
	   else if ( mylineinit[0] == "URL" ) 
	      card.webPage2 = mylinevalue;
	   else if ( title.test(mylineinit[0]) ) 
	      card.jobTitle = mylinevalue;
	   else if( bday.test(mylineinit[0]) ) {
	      bdayparts = mylinevalue.split("-");
	      card.birthYear = bdayparts[0];
	      card.birthMonth = bdayparts[1];
	      card.birthDay = bdayparts[2];
	   }
	}
	if (myfirstemail != "") {
	   // So there is an address with the PREF property
	   card.primaryEmail = myfirstemail;
	   card.secondEmail = myemail;
	}
	else if (myemail != "") {
	   // There isn't an address with the PREF property
	   card.primaryEmail = myemail;
	   card.secondEmail = myemail2;
	}
	if (key != "")
	   card.custom3 = key;
	if (serverVersion != "")
	   card.custom4 = serverVersion;

//	var directory = GetDirectoryFromURI(uri); 
// 	var addedCard = directory.addCard(card);
	
	return card;
}

function card2vcard(abCard) {
   var card = abCard.QueryInterface(Components.interfaces.nsIAbMDBCard);
   var quoted = "ENCODING=QUOTED-PRINTABLE:";
   var data = "";
   var vCard = "";
   var encoder = new QuotedPrintableEncoder();
   data = "BEGIN:VCARD\r\nVERSION:2.1\r\n";
   vCard = vCard + data;
   data = "N;"+ quoted + encoder.Encode(card.lastName) + ";" + encoder.Encode(card.firstName) + "\r\n";
   if (card.lastName != "" || card.firstName != "")
      vCard = vCard + data;
   data = "FN;ENCODING=QUOTED-PRINTABLE:"+encoder.Encode(card.displayName)+"\r\n";
   if (card.displayName != "")   
      vCard = vCard + data;
   data = "ORG:"+card.company+";"+card.department+"\r\n";
   if (! (card.company == "" && card.department == "")) 
      vCard = vCard + data;
   data = "NICKNAME:"+card.nickName+"\r\n";
   if (card.nickName != "") 
      vCard = vCard + data;
   data = "ADR;WORK;POSTAL:;;"+card.workAddress+";"+card.workCity+";"+card.workState+";"+card.workZipCode+";"+card.workCountry+"\r\n";
   if (data != "ADR;WORK;POSTAL:;;;;;;\r\n") 
      vCard = vCard + data;
   data = "LABEL;WORK;ENCODING=QUOTED-PRINTABLE:"+card.workAddress+"=0D=0A"+card.workCity+", "+card.workZipCode+" "+card.workCountry+"\r\n";
   if (data != "LABEL;WORK;ENCODING=QUOTED-PRINTABLE:=0D=0A,  \r\n") 
      vCard = vCard + data;
   data = "ADR;HOME;POSTAL:;;"+card.homeAddress+";"+card.homeCity+";"+card.homeState+";"+card.homeZipCode+";"+card.homeCountry+"\r\n";
   if (data != "ADR;HOME;POSTAL:;;;;;;\r\n") 
      vCard = vCard + data;
   data = "LABEL;HOME;ENCODING=QUOTED-PRINTABLE:"+encoder.Encode(card.homeAddress)+"=0D=0A"+encoder.Encode(card.homeCity)+", "+encoder.Encode(card.homeZipCode)+" "+encoder.Encode(card.homeCountry)+"\r\n";
   if (data != "LABEL;HOME;ENCODING=QUOTED-PRINTABLE:=0D=0A,  \r\n" ) 
      vCard = vCard + data;
   data = "TEL;WORK;VOICE:"+ card.workPhone+"\r\n";
   if (card.workPhone != "") 
      vCard = vCard + data;
   data = "TEL;HOME;VOICE:"+ card.homePhone+"\r\n";
   if (card.homePhone != "") 
      vCard = vCard + data;
   data = "TEL;CELL;VOICE:"+ card.cellularNumber+"\r\n";
   if (card.cellularNumber != "") 
      vCard = vCard + data;
   data = "TEL;FAX:"+ card.faxNumber+"\r\n";
   if (card.faxNumber != "") 
      vCard = vCard + data;
   data = "EMAIL;PREF;INTERNET:"+ card.primaryEmail+"\r\n";
   if (card.primaryEmail != "") 
      vCard = vCard + data;
   data = "EMAIL;INTERNET:"+ card.secondEmail+"\r\n";
   if (card.secondEmail != "") 
      vCard = vCard + data;
   data = "URL;HOME:"+ card.webPage2+"\r\n";
   if (card.webPage2 != "") 
      vCard = vCard + data;
   data = "TITLE:"+ card.jobTitle+"\r\n";
   if (card.jobTitle != "") 
      vCard = vCard + data;
   data = "URL;WORK:"+ card.webPage1+"\r\n";
   if (card.webPage1 != "") 
      vCard = vCard + data;
   data = "BDAY:"+card.birthYear+"-"+card.birthMonth+"-"+card.birthDay+"\r\n";
   if (card.birthYear != "" && card.birthMonth != "" && card.birthDay !="") 
      vCard = vCard + data;
   if (card.notes != "") {
      data = "NOTE;ENCODING=QUOTED-PRINTABLE:"+encoder.Encode(card.notes);
      vCard = vCard + data + "\r\n";
   }
   var fbUrl = card.getStringAttribute("calFBURL");
   if (fbUrl && fbUrl.length > 0) {
     data = "FBURL:"+fbUrl;
     vCard = vCard + data + "\r\n";
   }
   data = "END:VCARD\r\n\r\n";

   return vCard + data;
}

// This is needed just for the displayed name: Thunderbird wants it in QUOTE-PRINTABLE
// format in 7bit, otherwise it won't display correctly the special chars.
// It's a strange beahviour because there seems to be just for this field.
// This function is not perfect, but works quite well, I hope... '
function quoteprint(str) {
  var UC  = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  UC.charset="UTF-8";
  str = str.replace(/\=/g, "%");
  str = unescape(str);
  try { str = UC.ConvertToUnicode(str); }
  catch(e) {}

  return str;
}

/* qp encoder */
function QuotedPrintableEncoder() {
   this.MaxLineSize = 76;
   // Exclamation point through less than, and greater than through tilde
   // Tab is not listed here as UnAltered but could be
   this.UnAltered = String.fromCharCode(32) + String.fromCharCode(60) + String.fromCharCode(62) + String.fromCharCode(126);
   this.UnAlteredEnd = String.fromCharCode(33) + String.fromCharCode(60) + String.fromCharCode(62) + String.fromCharCode(126);

   return this;
}

QuotedPrintableEncoder.prototype.Encode = function(InputText) {
   var re = new RegExp("\r\n","g");
   var SplitText, i, s="";
   SplitText = InputText.split(re);
   for (i=0; i<SplitText.length; ++i)
      s += this.EncodeLine(SplitText[i]) + "\r\n";

   return s.substring(0, s.length - 2);
}

QuotedPrintableEncoder.prototype.EncodeLine = function(Text) {
   var SplitText, i, s="", c=256;
   if (Text.length == 0)
      return "";
   for (i=0; i<Text.length-1; ++i)
      s += this.EncodeCharacter(Text.charCodeAt(i), this.UnAltered);
   // Encode last character; if space, encode it
   s += this.EncodeCharacter(Text.charCodeAt(Text.length-1), this.UnAlteredEnd);
   if (s.length <= this.MaxLineSize)
      return s;
   // Split into lines of MaxLineSize characters or less
   SplitText = s.slice(0, this.MaxLineSize);
   i = this.MaxLineSize;
   while (i<s.length) {
      SplitText += "=\r\n"+ s.slice(i, i+this.MaxLineSize);
      i += this.MaxLineSize;
   }

   return SplitText;
}

QuotedPrintableEncoder.prototype.EncodeCharacter = function(Character, UnAltered) {
   var i, x, Alter=true;
   for (i=0; i<UnAltered.length; i+=2)
      if (Character >= UnAltered.charCodeAt(i) && Character <= UnAltered.charCodeAt(i+1))
         Alter=false;
   if (!Alter)
      return String.fromCharCode(Character);
   x = Character.toString(16).toUpperCase();

   return (x.length == 1) ? "=0" + x : "=" + x;
}
